include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext MonoPattern
ext BlockPattern, UfoPattern
ext UfoRowCenterXd_
ext Ground_

dseg
Reg2Value:
    defb 0
Reg4Value:
    defb 0


pSource equ ZW0
wVram equ ZW1
count equ ZB0
VramH equ ZB1
shift equ ZB1
charByte equ ZB2

cseg
ColorSource:
defb 8,$f0 ; Ascii
defb 2,$70 ; Logo
defb 1,$e0 ; Remain
defb 3,$70 ; BlockA
defb 3,$90 ; BlockB
defb 3,$b0 ; BlockC
defb 0
cseg
InitVram: public InitVram
    lda #0 | sta <VramH
    do
        sei
            lda #low Vram_PatternGenerator | sta VdpWritePort+1
            lda #high(Vram_PatternGenerator) or $40 | ora <VramH | sta VdpWritePort+1

            lda #low MonoPattern | sta <pSource
            lda #high MonoPattern | sta <pSource+1
            ldx #Char_BlockA
            jsr CopyToVdp
        cli
        lda #low Vram_PatternGenerator+Char_BlockA*CharHeight | sta wVram
        lda #high(Vram_PatternGenerator+Char_BlockA*CharHeight) or $40 | sta wVram+1

        lda #low BlockPattern | sta <pSource
        lda #high BlockPattern | sta <pSource+1

        lda #3 | sta <count
        do
            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | ora <VramH | sta VdpWritePort+1
                ldx #4
                jsr CopyToVdp
            cli
            lda <wVram | clc|adc #CharHeight*24 | sta <wVram
            lda <wVram+1 | adc #0 | sta <wVram+1
            dec <count
        while ne | wend
        lda <VramH | clc|adc #8 | sta <VramH
        cmp #8*3
    while ne | wend

    sei
        lda #low Vram_Color | sta VdpWritePort+1
        lda #high(Vram_Color) or $40 | sta VdpWritePort+1
        ldx #0
        do
            lda ColorSource,x
        while ne
            sta <count
            inx
            lda ColorSource,x | inx
            do
                sta VdpWritePort
                jsr WaitVdp
                dec <count
            while ne | wend
        wend
    cli
WaitVdp: public WaitVdp
rts

CopyToVdp:
    do
        ldy #0
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            jsr WaitVdp
            cpy #8
        while ne | wend
        lda <pSource | clc|adc #8 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1
        dex
    while ne | wend
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #$18 | sta <VramH
        do
            sei
                lda #low Vram_PatternName | sta VdpWritePort+1
                lda #high(Vram_PatternName) or $40 | ora <VramH | sta VdpWritePort+1
                lda #Char_Space
                ldy #3
                do
                    ldx #0
                    do
                        sta VdpWritePort
                        jsr WaitVdp
                        dex
                    while ne | wend
                    dey
                while ne | wend
            cli
            lda <VramH | clc|adc #$04 | sta <VramH
            cmp #$20
        while ne | wend
        lda #$06 | sta VdpWritePort+1
        lda #2 or $80 | sta VdpWritePort+1
        lda #$07 | sta Reg2Value

        lda #$00 | sta VdpWritePort+1
        ldx #4 or $80 | stx VdpWritePort+1
        lda #$01 | sta Reg4Value
    pla
rts


; ptr<byte> Put(word vram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_vram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put:
    tax
    sei
        lda Put_vram | sta VdpWritePort+1
        lda Put_vram+1 | ora #$40 | sta VdpWritePort+1
        stx VdpWritePort
    cli
    jsr WaitVdp
    sei
        lda Put_vram | sta VdpWritePort+1
        lda Put_vram+1 | ora #$44 | sta VdpWritePort+1
        stx VdpWritePort
    cli
rts
Put_: public Put_
    pha
        lda Put_c
        jsr Put
        lda Put_vram | clc|adc #1 | tay
        lda Put_vram+1 | adc #0 | tax
    pla
rts


; void UpdateChars();
cseg
UpdateChars_: public UpdateChars_
    pha
        lda Reg4Value
        if eq
            lda #low(4000h+Vram_PatternGenerator+(Char_BlockA+4)*CharHeight) | sta <wVram
            lda #high(4000h+Vram_PatternGenerator+(Char_BlockA+4)*CharHeight) | sta <wVram+1
        else
            lda #low(4000h+Vram_PatternGenerator2+(Char_BlockA+4)*CharHeight) | sta <wVram
            lda #high(4000h+Vram_PatternGenerator2+(Char_BlockA+4)*CharHeight) | sta <wVram+1
        endif
        lda #8
        sec|sbc UfoRowCenterXd_
        sta <shift

        lda #low UfoPattern | sta <pSource
        lda #high UfoPattern | sta <pSource+1
        lda #3 | sta <count
        do
            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | sta VdpWritePort+1
                ldy #0
                do
                    lda (<pSource),y | iny
                    sta <charByte
                    ldx <shift
                    if ne
                        lda (<pSource),y | iny
                        do
                            asl a
                            rol <charByte
                            dex
                        while ne | wend
                    endif
                    lda <charByte | sta VdpWritePort
                    cpy #14*CharHeight*2
                while ne | wend
            cli
            lda <pSource | clc|adc #14*CharHeight*2 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <wVram | clc|adc #CharHeight*24 | sta <wVram
            lda <wVram+1 | adc #0 | sta <wVram+1

            dec <count
        while ne | wend
    pla
rts


; void SwitchChars();
cseg
SwitchChars_: public SwitchChars_
    pha
        lda Reg4Value
        tax
        eor #$01
        sta Reg4Value
        sei
            stx VdpWritePort+1
            lda #4 or $80 | sta VdpWritePort+1
        cli
    pla
rts


; word CurrentPage();
cseg
CurrentPage_: public CurrentPage_
    pha
        lda Reg2Value
        cmp #6
        if eq
            ldx #high Vram_PatternName
        else
            ldx #high Vram_PatternName2
        endif
        ldy #0
    pla
rts


; void SwitchPage();
cseg
SwitchPage_: public SwitchPage_
    pha
        lda Reg2Value
        tax
        eor #$01
        sta Reg2Value
        sei
            stx VdpWritePort+1
            lda #2 or $80 | sta VdpWritePort+1
        cli
    pla
rts


; void WriteVram(word vram, byte b);
dseg
WriteVram_@Param0: public WriteVram_@Param0
WriteVram_vram:
    defw 0
WriteVram_@Param1: public WriteVram_@Param1
WriteVram_c:
    defb 0
cseg
WriteVram_: public WriteVram_
    sei
        lda WriteVram_vram | sta VdpWritePort+1
        lda WriteVram_vram+1 | ora #$40 | sta VdpWritePort+1
        lda WriteVram_c
        sta VdpWritePort
    cli
rts


; void CopyToVram(word vram, ptr<byte> pBytes, byte count);
dseg
CopyToVram_@Param0: public CopyToVram_@Param0
CopyToVram_vram:
    defw 0
CopyToVram_@Param1: public CopyToVram_@Param1
CopyToVram_pBytes:
    defw 0
CopyToVram_@Param2: public CopyToVram_@Param2
CopyToVram_count:
    defb 0
cseg
CopyToVram_: public CopyToVram_
    pha
        lda CopyToVram_pBytes | sta <pSource
        lda CopyToVram_pBytes+1 | sta <pSource+1
        sei
            lda CopyToVram_vram | sta VdpWritePort+1
            lda CopyToVram_vram+1 | ora #$40 | sta VdpWritePort+1
            ldy #0
            ldx CopyToVram_count
            do
                lda (<pSource),y | iny
                sta VdpWritePort
                jsr WaitVdp
                dex
            while ne | wend
        cli
    pla
rts


Ground_BlockMask equ $03
Ground_BombMask equ $0c

; void DrawBackground();
dseg
RowBuff:
    defs VramWidth*2
cseg
DrawBackground_: public DrawBackground_
    pha
        ldy #0
        do
            lda Ground_,y
            tax
            and #Ground_BombMask
            if ne
                lsr a | lsr a
                adc #Char_BlockC-1
                jmp DrawBackground_write
            endif
            txa
            and #Ground_BlockMask
            if ne
                adc #Char_BlockA-1
                DrawBackground_write:
                sta RowBuff,y
                adc #2
                sta RowBuff+VramWidth,y
            else
                lda #Char_Space
                sta RowBuff,y
                sta RowBuff+VramWidth,y
            endif
            iny
            cpy #VramWidth
        while ne | wend

        jsr CurrentPage_
        lda #VramWidth*2 | sta <wVram
        txa | ora #$40 | sta <wVram+1
        ldy #6
        do
            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | sta VdpWritePort+1
                lda #Char_Space
                ldx #VramWidth*2+1
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
            cli
            lda <wVram | clc|adc #VramWidth*3 | sta <wVram
            lda <wVram+1 | adc #0 | sta <wVram+1
            dey
        while ne | wend

        sei
            lda <wVram | clc|adc #VramWidth*2 | sta VdpWritePort+1
            lda <wVram+1 | adc #0 | sta VdpWritePort+1
            ldx #0
            do
                lda RowBuff,x | inx
                sta VdpWritePort
                jsr WaitVdp
                cpx #VramWidth
            while ne | wend
            ldx #0
            do
                lda RowBuff+VramWidth,x | inx
                sta VdpWritePort
                jsr WaitVdp
                cpx #VramWidth
            while ne | wend
        cli
    pla
rts
